local s=require"nixio.fs"
local h=require"luci.sys"
local u=require"luci.util"
local r=require"luci.dispatcher"
local l=require"luci.cbi.datatypes"
local a=require"luci.controller.privoxy"
local t=[[<a href="http://www.privoxy.org/user-manual/config.html#%s" target="_blank">%s</a>]]
local o=a.ipkg_ver_installed("privoxy")
local e=a.ipkg_ver_compare(o,">=",a.PRIVOXY_MIN)
local i=[[</a><a href="javascript:alert(']]
..translate("Version Information")
..[[\n\nluci-app-privoxy]]
..[[\n\t]]..translate("Version")..[[:\t]]
..a.ipkg_ver_installed("luci-app-privoxy")
..[[\n\nprivoxy ]]..translate("required")..[[:]]
..[[\n\t]]..translate("Version")..[[:\t]]..a.PRIVOXY_MIN..[[ ]]..translate("or higher")
..[[\n\nprivoxy ]]..translate("installed")..[[:]]
..[[\n\t]]..translate("Version")..[[:\t]]..o
..[[\n\n]]
..[[')">]]
..translate("Privoxy WEB proxy")
local n=translate("Privoxy is a non-caching web proxy with advanced filtering "
.."capabilities for enhancing privacy, modifying web page data and HTTP headers, "
.."controlling access, and removing ads and other obnoxious Internet junk.")
..[[<br /><strong>]]
..translate("For help use link at the relevant option")
..[[</strong>]]
if not nixio.fs.access("/etc/config/privoxy")or not e then
local e=SimpleForm("_no_config")
e.title=i
e.description=n
e.embedded=true
e.submit=false
e.reset=false
local t=e:section(SimpleSection)
t.title=[[<font color="red">]]..[[<strong>]]
..translate("Software update required")
..[[</strong>]]..[[</font>]]
local t=t:option(DummyValue,"_update_needed")
t.titleref=r.build_url("admin","system","packages")
t.rawhtml=true
t.value=[[<h3><strong><br /><br />&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("The currently installed 'privoxy' package is not supported by LuCI application.")
..[[<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("required")..": "..a.PRIVOXY_MIN.." *** "..translate("installed")..": "..o
..[[<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("Please update to the current version!")
..[[<br /><br /></strong></h3>]]
return e
end
local d=Map("privoxy")
d.title=i
d.description=n
function d.commit_handler(e)
if e.changed then
os.execute("/etc/init.d/privoxy reload &")
end
end
local e=d:section(NamedSection,"privoxy","privoxy")
e:tab("local",
translate("Local Set-up"),
translate("If you intend to operate Privoxy for more users than just yourself, "
.."it might be a good idea to let them know how to reach you, what you block "
.."and why you do that, your policies, etc."))
local function c(t,a)
return string.format(translate("Local Set-up").." - %s: %s",t,a)
end
e:tab("filter",
translate("Files and Directories"),
translate("Privoxy can (and normally does) use a number of other files "
.."for additional configuration, help and logging. This section of "
.."the configuration file tells Privoxy where to find those other files."))
local function n(t,a)
return string.format(translate("Files and Directories").." - %s: %s",t,a)
end
e:tab("access",
translate("Access Control"),
translate("This tab controls the security-relevant aspects of Privoxy's configuration."))
local function r(t,a)
return string.format(translate("Access Control").." - %s: %s",t,a)
end
e:tab("forward",
translate("Forwarding"),
translate("Configure here the routing of HTTP requests through a chain of multiple proxies. "
.."Note that parent proxies can severely decrease your privacy level. "
.."Also specified here are SOCKS proxies."))
e:tab("misc",
translate("Miscellaneous"),
nil)
local function o(a,t)
return string.format(translate("Miscellaneous").." - %s: %s",a.title_base,t)
end
e:tab("debug",
translate("Logging"),
nil)
e:tab("logview",
translate("Log File Viewer"),
nil)
local i=e:taboption("local",Button,"_startstop")
i.title=translate("Start / Stop")
i.description=translate("Start/Stop Privoxy WEB Proxy")
i.template="privoxy/detail_startstop"
function i.cfgvalue(e,e)
local e=a.get_pid(true)
if e>0 then
i.inputtitle="PID: "..e
i.inputstyle="reset"
i.disabled=false
else
i.inputtitle=translate("Start")
i.inputstyle="apply"
i.disabled=false
end
return true
end
local i=e:taboption("local",Flag,"_enabled")
i.title=translate("Enabled")
i.description=translate("Enable/Disable autostart of Privoxy on system startup and interface events")
i.orientation="horizontal"
i.rmempty=false
function i.cfgvalue(e,e)
return(h.init.enabled("privoxy"))and"1"or"0"
end
function i.validate(t,e)
error("Validate "..e)
end
function i.write(t,t,e)
if e=="1"then
return h.init.enable("privoxy")
else
return h.init.disable("privoxy")
end
end
local i=e:taboption("local",Value,"hostname")
i.title=string.format(t,"HOSTNAME","Hostname")
i.description=translate("The hostname shown on the CGI pages.")
i.placeholder=h.hostname()
i.optional=true
i.rmempty=true
local i=e:taboption("local",Value,"user_manual")
i.title=string.format(t,"USER-MANUAL","User Manual")
i.description=translate("Location of the Privoxy User Manual.")
i.placeholder="http://www.privoxy.org/user-manual/"
i.optional=true
i.rmempty=true
local i=e:taboption("local",Value,"admin_address")
i.title_base="Admin Email"
i.title=string.format(t,"ADMIN-ADDRESS",i.title_base)
i.description=translate("An email address to reach the Privoxy administrator.")
i.placeholder="privoxy.admin@example.com"
i.optional=true
i.rmempty=true
function i.validate(t,e)
if not e or#e==0 then
return""
end
if not(e:match("[A-Za-z0-9%.%%%+%-]+@[A-Za-z0-9%.%%%+%-]+%.%w%w%w?%w?"))then
return nil,c(t.title_base,translate("Invalid email address"))
end
return e
end
local i=e:taboption("local",Value,"proxy_info_url")
i.title=string.format(t,"PROXY-INFO-URL","Proxy Info URL")
i.description=translate("A URL to documentation about the local Privoxy setup, configuration or policies.")
i.optional=true
i.rmempty=true
local i=e:taboption("local",Value,"trust_info_url")
i.title=string.format(t,"TRUST-INFO-URL","Trust Info URLs")
i.description=translate("A URL to be displayed in the error page that users will see if access to an untrusted page is denied.")
..[[<br /><strong>]]
..translate("The value of this option only matters if the experimental trust mechanism has been activated.")
..[[</strong>]]
i.optional=true
i.rmepty=true
local i=e:taboption("filter",Value,"logdir")
i.title_base="Log Directory"
i.title=string.format(t,"LOGDIR",i.title_base)
i.description=translate("The directory where all logging takes place (i.e. where the logfile is located).")
..[[<br />]]
..translate("No trailing '/', please.")
i.default="/var/log"
i.rmempty=false
function i.validate(t,e)
if not e or#e==0 then
return nil,n(t.title_base,translate("Mandatory Input: No Directory given!"))
elseif not s.access(e)then
return nil,n(t.title_base,translate("Directory does not exist!"))
else
return e
end
end
local i=e:taboption("filter",Value,"logfile")
i.title_base="Log File"
i.title=string.format(t,"LOGFILE",i.title_base)
i.description=translate("The log file to use. File name, relative to log directory.")
i.default="privoxy.log"
i.rmempty=false
function i.validate(t,e)
if not e or#e==0 then
return nil,n(t.title_base,translate("Mandatory Input: No File given!"))
else
return e
end
end
local i=e:taboption("filter",Value,"confdir")
i.title_base="Configuration Directory"
i.title=string.format(t,"CONFDIR",i.title_base)
i.description=translate("The directory where the other configuration files are located.")
..[[<br />]]
..translate("No trailing '/', please.")
i.default="/etc/privoxy"
i.rmempty=false
function i.validate(t,e)
if not e or#e==0 then
return nil,n(t.title_base,translate("Mandatory Input: No Directory given!"))
elseif not s.access(e)then
return nil,n(t.title_base,translate("Directory does not exist!"))
else
return e
end
end
local h=e:taboption("filter",Value,"templdir")
h.title_base="Template Directory"
h.title=string.format(t,"TEMPLDIR",h.title_base)
h.description=translate("An alternative directory where the templates are loaded from.")
..[[<br />]]
..translate("No trailing '/', please.")
h.placeholder="/etc/privoxy/templates"
h.rmempty=true
function h.validate(t,e)
if not s.access(e)then
return nil,n(t.title_base,translate("Directory does not exist!"))
else
return e
end
end
local h=e:taboption("filter",Value,"temporary_directory")
h.title_base="Temporary Directory"
h.title=string.format(t,"TEMPORARY-DIRECTORY",h.title_base)
h.description=translate("A directory where Privoxy can create temporary files.")
..[[<br /><strong>]]
..translate("Only when using 'external filters', Privoxy has to create temporary files.")
..[[</strong>]]
h.rmempty=true
local h=e:taboption("filter",DynamicList,"actionsfile")
h.title_base="Action Files"
h.title=string.format(t,"ACTIONSFILE",h.title_base)
h.description=translate("The actions file(s) to use. Multiple actionsfile lines are permitted, and are in fact recommended!")
..[[<br /><strong>match-all.action := </strong>]]
..translate("Actions that are applied to all sites and maybe overruled later on.")
..[[<br /><strong>default.action := </strong>]]
..translate("Main actions file")
..[[<br /><strong>user.action := </strong>]]
..translate("User customizations")
h.rmempty=false
function h.validate(h,t)
if not t or#t==0 then
return nil,r(h.title_base,translate("Mandatory Input: No files given!"))
end
local i=i:formvalue(e.section)
local o=false
local a=""
if type(t)=="table"then
local e
for t,e in ipairs(t)do
if e and#e>0 then
if not s.access(i.."/"..e)then
o=true
a=e
break
end
end
end
else
if not s.access(i.."/"..t)then
o=true
a=t
end
end
if o then
return nil,string.format(n(h.title_base,translate("File '%s' not found inside Configuration Directory")),a)
end
return t
end
local h=e:taboption("filter",DynamicList,"filterfile")
h.title_base="Filter files"
h.title=string.format(t,"FILTERFILE",h.title_base)
h.description=translate("The filter files contain content modification rules that use regular expressions.")
h.rmempty=false
function h.validate(h,t)
if not t or#t==0 then
return nil,r(h.title_base,translate("Mandatory Input: No files given!"))
end
local i=i:formvalue(e.section)
local a=false
local o=""
if type(t)=="table"then
local e
for t,e in ipairs(t)do
if e and#e>0 then
if not s.access(i.."/"..e)then
a=true
o=e
break
end
end
end
else
if not s.access(i.."/"..t)then
a=true
o=t
end
end
if a then
return nil,string.format(n(h.title_base,translate("File '%s' not found inside Configuration Directory")),o)
end
return t
end
local h=e:taboption("filter",Value,"trustfile")
h.title_base="Trust file"
h.title=string.format(t,"TRUSTFILE",h.title_base)
h.description=translate("The trust mechanism is an experimental feature for building white-lists "
.."and should be used with care.")
..[[<br /><strong>]]
..translate("It is NOT recommended for the casual user.")
..[[</strong>]]
h.placeholder="user.trust"
h.rmempty=true
function h.validate(h,t)
local i=i:formvalue(e.section)
local a=false
local o=""
if type(t)=="table"then
local e
for t,e in ipairs(t)do
if e and#e>0 then
if not NCFS.access(i.."/"..e)then
a=true
o=e
break
end
end
end
else
if not s.access(i.."/"..t)then
a=true
o=t
end
end
if a then
return nil,string.format(n(h.title_base,translate("File '%s' not found inside Configuration Directory")),o)
end
return t
end
local i=e:taboption("access",DynamicList,"listen_address")
i.title_base="Listen addresses"
i.title=string.format(t,"LISTEN-ADDRESS",i.title_base)
i.description=translate("The address and TCP port on which Privoxy will listen for client requests.")
..[[<br />]]
..translate("Syntax: ")
.."IPv4:Port / [IPv6]:Port / Host:Port"
i.default="127.0.0.1:8118"
i.rmempty=false
function i.validate(o,t)
if not t or#t==0 then
return nil,r(o.title_base,translate("Mandatory Input: No Data given!"))
end
local function i(a)
local e=u.split(a,"]:")
local t
if e[2]then
t=string.gsub(e[1],"%[","")
if not l.ip6addr(t)then
return translate("Mandatory Input: No valid IPv6 address given!")
elseif not l.port(e[2])then
return translate("Mandatory Input: No valid Port given!")
else
return nil
end
end
e=u.split(a,":")
if not e[2]then
return translate("Mandatory Input: No Port given!")
end
if#e[1]>0 and not l.host(e[1])then
return translate("Mandatory Input: No valid IPv4 address or host given!")
elseif not l.port(e[2])then
return translate("Mandatory Input: No valid Port given!")
else
return nil
end
end
local e=""
local a=""
if type(t)=="table"then
local o
for o,t in ipairs(t)do
if t and#t>0 then
e=i(t)
if e then
a=t
break
end
end
end
else
e=i(t)
a=t
end
if e then
return nil,string.format(r(o.title_base,e.." - %s"),a)
end
return t
end
local i=e:taboption("access",DynamicList,"permit_access")
i.title=string.format(t,"ACLS","Permit access")
i.description=translate("Who can access what.")
..[[<br /><strong>]]
..translate("Please read Privoxy manual for details!")
..[[</strong>]]
i.rmempty=true
local i=e:taboption("access",DynamicList,"deny_access")
i.title=string.format(t,"ACLS","Deny Access")
i.description=translate("Who can access what.")
..[[<br /><strong>]]
..translate("Please read Privoxy manual for details!")
..[[</strong>]]
i.rmempty=true
local i=e:taboption("access",Value,"buffer_limit")
i.title_base="Buffer Limit"
i.title=string.format(t,"BUFFER-LIMIT",i.title_base)
i.description=translate("Maximum size (in KB) of the buffer for content filtering.")
..[[<br />]]
..translate("Value range 1 to 4096, no entry defaults to 4096")
i.default=4096
i.rmempty=true
function i.validate(t,a)
local e=tonumber(a)
if not e then
return nil,r(t.title_base,translate("Value is not a number"))
elseif e<1 or e>4096 then
return nil,r(t.title_base,translate("Value not between 1 and 4096"))
elseif e==t.default then
return""
end
return a
end
local i=e:taboption("access",Flag,"toggle")
i.title=string.format(t,"TOGGLE","Toggle Status")
i.description=translate("Enable/Disable filtering when Privoxy starts.")
..[[<br />]]
..translate("Disabled == Transparent Proxy Mode")
i.orientation="horizontal"
i.default="1"
i.rmempty=false
function i.parse(e,t)
a.flag_parse(e,t)
end
local i=e:taboption("access",Flag,"enable_remote_toggle")
i.title=string.format(t,"ENABLE-REMOTE-TOGGLE","Enable remote toggle")
i.description=translate("Whether or not the web-based toggle feature may be used.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(e,t)
a.flag_parse(e,t)
end
local i=e:taboption("access",Flag,"enable_remote_http_toggle")
i.title=string.format(t,"ENABLE-REMOTE-HTTP-TOGGLE","Enable remote toggle via HTTP")
i.description=translate("Whether or not Privoxy recognizes special HTTP headers to change toggle state.")
..[[<br /><strong>]]
..translate("This option will be removed in future releases as it has been obsoleted by the more general header taggers.")
..[[</strong>]]
i.orientation="horizontal"
i.rmempty=true
function i.parse(t,e)
a.flag_parse(t,e)
end
local i=e:taboption("access",Flag,"enable_edit_actions")
i.title=string.format(t,"ENABLE-EDIT-ACTIONS","Enable action file editor")
i.description=translate("Whether or not the web-based actions file editor may be used.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(e,t)
a.flag_parse(e,t)
end
local i=e:taboption("access",Flag,"enforce_blocks")
i.title=string.format(t,"ENFORCE-BLOCKS","Enforce page blocking")
i.description=translate("If enabled, Privoxy hides the 'go there anyway' link. "
.."The user obviously should not be able to bypass any blocks.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(e,t)
a.flag_parse(e,t)
end
local i=e:taboption("forward",Flag,"enable_proxy_authentication_forwarding")
i.title=string.format(t,"ENABLE-PROXY-AUTHENTICATION-FORWARDING",
translate("Enable proxy authentication forwarding"))
i.description=translate("Whether or not proxy authentication through Privoxy should work.")
..[[<br /><strong>]]
..translate("Enabling this option is NOT recommended if there is no parent proxy that requires authentication!")
..[[</strong>]]
i.rmempty=true
function i.parse(e,t)
a.flag_parse(e,t)
end
local i=e:taboption("forward",DynamicList,"forward")
i.title=string.format(t,"FORWARD","Forward HTTP")
i.description=translate("To which parent HTTP proxy specific requests should be routed.")
..[[<br />]]
..translate("Syntax: target_pattern http_parent[:port]")
i.rmempty=true
local i=e:taboption("forward",DynamicList,"forward_socks4")
i.title=string.format(t,"SOCKS","Forward SOCKS 4")
i.description=translate("Through which SOCKS proxy (and optionally to which parent HTTP proxy) specific requests should be routed.")
..[[<br />]]
..translate("Syntax: target_pattern socks_proxy[:port] http_parent[:port]")
i.rmempty=true
local n=e:taboption("forward",DynamicList,"forward_socks4a")
n.title=string.format(t,"SOCKS","Forward SOCKS 4A")
n.description=i.description
n.rmempty=true
local n=e:taboption("forward",DynamicList,"forward_socks5")
n.title=string.format(t,"SOCKS","Forward SOCKS 5")
n.description=i.description
n.rmempty=true
local n=e:taboption("forward",DynamicList,"forward_socks5t")
n.title=string.format(t,"SOCKS","Forward SOCKS 5t")
n.description=i.description
n.rmempty=true
local i=e:taboption("misc",Flag,"accept_intercepted_requests")
i.title=string.format(t,"ACCEPT-INTERCEPTED-REQUESTS","Accept intercepted requests")
i.description=translate("Whether intercepted requests should be treated as valid.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(t,e)
a.flag_parse(t,e)
end
local i=e:taboption("misc",Flag,"allow_cgi_request_crunching")
i.title=string.format(t,"ALLOW-CGI-REQUEST-CRUNCHING","Allow CGI request crunching")
i.description=translate("Whether requests to Privoxy's CGI pages can be blocked or redirected.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(e,t)
a.flag_parse(e,t)
end
local i=e:taboption("misc",Flag,"split_large_forms")
i.title=string.format(t,"SPLIT-LARGE-FORMS","Split large forms")
i.description=translate("Whether the CGI interface should stay compatible with broken HTTP clients.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(t,e)
a.flag_parse(t,e)
end
local i=e:taboption("misc",Value,"keep_alive_timeout")
i.title_base="Keep-alive timeout"
i.title=string.format(t,"KEEP-ALIVE-TIMEOUT",i.title_base)
i.description=translate("Number of seconds after which an open connection will no longer be reused.")
i.rmempty=true
function i.validate(t,a)
local e=tonumber(a)
if not e then
return nil,o(t.title_base,translate("Value is not a number"))
elseif e<1 then
return nil,o(t.title_base,translate("Value not greater 0 or empty"))
end
return a
end
local i=e:taboption("misc",Flag,"tolerate_pipelining")
i.title=string.format(t,"TOLERATE-PIPELINING","Tolerate pipelining")
i.description=translate("Whether or not pipelined requests should be served.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(t,e)
a.flag_parse(t,e)
end
local i=e:taboption("misc",Value,"default_server_timeout")
i.title_base="Default server timeout"
i.title=string.format(t,"DEFAULT-SERVER-TIMEOUT",i.title_base)
i.description=translate("Assumed server-side keep-alive timeout (in seconds) if not specified by the server.")
i.rmempty=true
function i.validate(e,t)
local a=tonumber(t)
if not a then
return nil,o(e.title_base,translate("Value is not a number"))
elseif a<1 then
return nil,o(e.title_base,translate("Value not greater 0 or empty"))
end
return t
end
local i=e:taboption("misc",Flag,"connection_sharing")
i.title=string.format(t,"CONNECTION-SHARING","Connection sharing")
i.description=translate("Whether or not outgoing connections that have been kept alive should be shared between different incoming connections.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(t,e)
a.flag_parse(t,e)
end
local i=e:taboption("misc",Value,"socket_timeout")
i.title_base="Socket timeout"
i.title=string.format(t,"SOCKET-TIMEOUT",i.title_base)
i.description=translate("Number of seconds after which a socket times out if no data is received.")
i.default=300
i.rmempty=true
function i.validate(t,a)
local e=tonumber(a)
if not e then
return nil,o(t.title_base,translate("Value is not a number"))
elseif e<1 then
return nil,o(t.title_base,translate("Value not greater 0 or empty"))
elseif e==t.default then
return""
end
return a
end
local i=e:taboption("misc",Value,"max_client_connections")
i.title_base="Max. client connections"
i.title=string.format(t,"MAX-CLIENT-CONNECTIONS",i.title_base)
i.description=translate("Maximum number of client connections that will be served.")
i.default=128
i.rmempty=true
function i.validate(t,a)
local e=tonumber(a)
if not e then
return nil,o(t.title_base,translate("Value is not a number"))
elseif e<1 then
return nil,o(t.title_base,translate("Value not greater 0 or empty"))
elseif e==t.default then
return""
end
return a
end
local i=e:taboption("misc",Flag,"handle_as_empty_doc_returns_ok")
i.title=string.format(t,"HANDLE-AS-EMPTY-DOC-RETURNS-OK","Handle as empty doc returns ok")
i.description=translate("The status code Privoxy returns for pages blocked with +handle-as-empty-document.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(t,e)
a.flag_parse(t,e)
end
local i=e:taboption("misc",Flag,"enable_compression")
i.title=string.format(t,"ENABLE-COMPRESSION","Enable compression")
i.description=translate("Whether or not buffered content is compressed before delivery.")
i.orientation="horizontal"
i.rmempty=true
function i.parse(t,e)
a.flag_parse(t,e)
end
local i=e:taboption("misc",Value,"compression_level")
i.title_base="Compression level"
i.title=string.format(t,"COMPRESSION-LEVEL",i.title_base)
i.description=translate("The compression level that is passed to the zlib library when compressing buffered content.")
i.default=1
i.rmempty=true
function i.validate(t,a)
local e=tonumber(a)
if not e then
return nil,o(t.title_base,translate("Value is not a number"))
elseif e<0 or e>9 then
return nil,o(t.title_base,translate("Value not between 0 and 9"))
elseif e==t.default then
return""
end
return a
end
local o=e:taboption("misc",Value,"client_header_order")
o.title=string.format(t,"CLIENT-HEADER-ORDER","Client header order")
o.description=translate("The order in which client headers are sorted before forwarding them.")
..[[<br />]]
..translate("Syntax: Client header names delimited by spaces.")
o.rmempty=true
local o=e:taboption("debug",Flag,"single_threaded")
o.title=string.format(t,"SINGLE-THREADED","Single Threaded")
o.description=translate("Whether to run only one server thread.")
..[[<br /><strong>]]
..translate("This option is only there for debugging purposes. It will drastically reduce performance.")
..[[</strong>]]
o.rmempty=true
function o.parse(t,e)
a.flag_parse(t,e)
end
local o=e:taboption("debug",Flag,"debug_1")
o.title=string.format(t,"DEBUG","Debug 1")
o.description=translate("Log the destination for each request Privoxy let through. See also 'Debug 1024'.")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_2")
o.title=string.format(t,"DEBUG","Debug 2")
o.description=translate("Show each connection status")
o.rmempty=true
function o.parse(t,e)
a.flag_parse(t,e)
end
local o=e:taboption("debug",Flag,"debug_4")
o.title=string.format(t,"DEBUG","Debug 4")
o.description=translate("Show I/O status")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_8")
o.title=string.format(t,"DEBUG","Debug 8")
o.description=translate("Show header parsing")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_16")
o.title=string.format(t,"DEBUG","Debug 16")
o.description=translate("Log all data written to the network")
o.rmempty=true
function o.parse(t,e)
a.flag_parse(t,e)
end
local o=e:taboption("debug",Flag,"debug_32")
o.title=string.format(t,"DEBUG","Debug 32")
o.description=translate("Debug force feature")
o.rmempty=true
function o.parse(t,e)
a.flag_parse(t,e)
end
local o=e:taboption("debug",Flag,"debug_64")
o.title=string.format(t,"DEBUG","Debug 64")
o.description=translate("Debug regular expression filters")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_128")
o.title=string.format(t,"DEBUG","Debug 128")
o.description=translate("Debug redirects")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_256")
o.title=string.format(t,"DEBUG","Debug 256")
o.description=translate("Debug GIF de-animation")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_512")
o.title=string.format(t,"DEBUG","Debug 512")
o.description=translate("Common Log Format")
o.rmempty=true
function o.parse(t,e)
a.flag_parse(t,e)
end
local o=e:taboption("debug",Flag,"debug_1024")
o.title=string.format(t,"DEBUG","Debug 1024")
o.description=translate("Log the destination for requests Privoxy didn't let through, and the reason why.")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_2048")
o.title=string.format(t,"DEBUG","Debug 2048")
o.description=translate("CGI user interface")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_4096")
o.title=string.format(t,"DEBUG","Debug 4096")
o.description=translate("Startup banner and warnings.")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_8192")
o.title=string.format(t,"DEBUG","Debug 8192")
o.description=translate("Non-fatal errors - *we highly recommended enabling this*")
o.rmempty=true
function o.parse(t,e)
a.flag_parse(t,e)
end
local o=e:taboption("debug",Flag,"debug_32768")
o.title=string.format(t,"DEBUG","Debug 32768")
o.description=translate("Log all data read from the network")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local o=e:taboption("debug",Flag,"debug_65536")
o.title=string.format(t,"DEBUG","Debug 65536")
o.description=translate("Log the applying actions")
o.rmempty=true
function o.parse(e,t)
a.flag_parse(e,t)
end
local t=e:taboption("logview",DummyValue,"_logview")
t.template="privoxy/detail_logview"
t.inputtitle=translate("Read / Reread log file")
t.rows=50
function t.cfgvalue(t,a)
local e=t.map:get(e.section,"logdir").."/"..t.map:get(e.section,"logfile")
if s.access(e)then
return e.."\n"..translate("Please press [Read] button")
end
return e.."\n"..translate("File not found or empty")
end
return d
